/***************************************************************************
 *
 * This is a part of AntMon project
 *
 *            ant_log.cpp
 *
 *  Tue Aug 22 14:33:28 2006
 *  Copyright  2006  Sergey Zhumatiy
 *  serg@parallel.ru
 ****************************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdarg.h>
#include <syslog.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <time.h>

int log_to_syslog=0;
//int log_to_stderr=0;
char *log_name=NULL;

#define MAX_BUF 1024
#define TIM_MAX 24

static char buf[MAX_BUF];
static char tim[TIM_MAX];
int         log_level=0xffff;

//
//  log to syslog or stderr
//
void log(const char *s,...){
  va_list vl;
  time_t t;
  struct tm *tmp;

  va_start(vl,s);
  vsnprintf(buf,MAX_BUF-1,s,vl);
  buf[MAX_BUF-1]='\0';
  if(log_to_syslog) {
    openlog(log_name,LOG_PID,LOG_USER);
    syslog(LOG_INFO,"%s",buf);
    closelog();
  }
  else{
    t = time(NULL);
    tmp = localtime(&t);

    strftime(tim, TIM_MAX,"[%d-%m-%y %H:%M:%S]", tmp);
    fprintf(stderr, "%s %s\n", tim, buf);
  }
  va_end(vl);
}
