#ifndef ANT_MOD_HPP
#define ANT_MOD_HPP

#include <sys/types.h>
#include <string>
#include <list>
#include <map>

using namespace std;

#include "ant_log.hpp"
#define ANT_MOD_BUF_CHUNK 2048

class Ant_agent_sensor;

struct Ant_int{
  long int value;
  operator long int(){return value;};

  Ant_int(long int val=0){value=val;};
  Ant_int(const Ant_int&a){value=a.value;};
};

class Ant_agent_module{
  static char error_buf[ANT_MOD_BUF_CHUNK];
  static long int _id;
  long int _new_id();
public:
  static int    send_retr;
  static struct timeval sleep_time;
  static string modules_path;

  static map<string, Ant_int *> global_ids;
  static map<string, int *> global_exe;
  static map<string, int *> global_err;

  int           fd;            /* i/o descriptor */
  int           ed;            /* stderr redirect */

  char          *name;         /* modeule name */
  char          *exe;          /* exe name+args */

  time_t        data_sent;     /* when last request was sent */
  time_t        next_try;      /* next try sceduled time */

  int           active;        /* is enabled */
  int           error;         /* has an error */

  list<Ant_agent_sensor *> sent_ids; /* requested sensors list */

  char          *buffer;       /* read chars */
  int           size;          /* read buffer size */
  int           pos;           /* read buffer position */
  char          *out_buffer;   /* chars to send */
  int           out_size;      /* size of send buffer */
  int           out_pos;       /* send buffer position */

  int           request(Ant_agent_sensor *);
  void          sendMessage(const char *);
  int           readMessage();             // 1 if full message is gotten
  int           flush();                   // 1 if error
  void          clean();

  const char    *readErrors();

  void register_sensor(char *); // for universal modules

  Ant_agent_module(const char *);
  ~Ant_agent_module();

  void finalize();
  void init(const char *);
};

#endif
